/*
 * AppTaskCan.c
 *
 *  Created on: 2022年2月8日
 *      Author: QiXiang_CHENJIE
 */
#include "AppTaskCan.h"
static void CanDataAsk(QueueDataTrans_Type AskData);
uint8 DataPackCounter[21] = {1,1,7,5,16,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
static void UdsAns(bool PosFlg,uint8 UdsService,uint8 UdsSubService,uint8 Idx,uint8 *AnsData,uint8 AnsDataLen);
void udsService(uint8 *DataIn);
static void vCanRxCallback(TimerHandle_t pxTimer)
{
	uint32 ulTimerID;
	ulTimerID = (uint32)pvTimerGetTimerID(pxTimer);
	if(ulTimerID==0)
	{
		Can_MainFunction_Read();
	}
}
     
void CanTask(void *data)
{
	(void)data;
	CanRecvQueueHandle   = xQueueCreate(16, sizeof(Can_Msg_Type_Data));  // CAN获取消息队列创建:CAN接收队列,接收EBC的CAN报文

	Uart2ToCanDataHandle = xQueueCreate(2, sizeof(QueueDataTrans_Type)); // CAN数据查询队列创建:CAN发送队列,发送CAN报文给EBC

	CanToUart2DataHandle = xQueueCreate(1, sizeof(QueueDataTrans_Type)); // CAN数据回复队列创建:从机的WIFI通讯的发送队列
	uint8 CanState = 0;
	CanIf_bRxFlag = false;
	Can_Msg_Type_Data CanRxMsg;
	QueueDataTrans_Type CanAskData={0,NULL};

	TimerHandle_t monitorTimer1ms;
	monitorTimer1ms = xTimerCreate("monitor1ms",1,pdTRUE,(void *)0,vCanRxCallback);
	xTimerStart(monitorTimer1ms,0);

	while (TRUE)
	{
		switch (CanState)
		{
			case 0:
			{
				CanState = 1;
				break;
			}
			case 1:
			{
				memset(&CanRxMsg, 0, sizeof(CanRxMsg));
	//			Can_MainFunction_Read();
				BaseType_t ret = xQueueReceive(CanRecvQueueHandle, &CanRxMsg, 0);
				if (ret == pdPASS)
				{
					BleCanTransmit(CanRxMsg.id, CanRxMsg.data);
				}
				BaseType_t ret2 = xQueueReceive(Uart2ToCanDataHandle,&CanAskData,10);//带有校验码
				if (ret2 == pdPASS)
				{
					CanDataAsk(CanAskData);
				}
//				vTaskDelay(pdMS_TO_TICKS(10));
				break;
			}
		}
	}
}
static void CanDataAsk(QueueDataTrans_Type AskData)
{
	Can_Msg_Type CanTxMsg;
	uint16 CrcGet = 0x00;
	uint16 CrcCal = 0xff;
	if(AskData.RealLen==10)
	{
		CrcGet = (*(AskData.DataPtr + AskData.RealLen - 2)<<0 )| (*(AskData.DataPtr + AskData.RealLen - 1)<<8 );
		CrcCal = CRC16_Modbus(AskData.DataPtr,AskData.RealLen-2);
		if(CrcGet==CrcCal)
		{
			CanTxMsg.id = 0X1CEF0000;
			CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
			CanTxMsg.sdu = AskData.DataPtr;
			CanTxMsg.length = 8;
			CanIf_SendMessage(0, CanTxMsg);
		}
	}
	else if(AskData.RealLen==1)//从机连接与断开，主动给EBC发送一帧状态
	{
		CanTxMsg.id = 0X1CEF0002;
		CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
		CanTxMsg.sdu = AskData.DataPtr;
		CanTxMsg.length = 8;
		CanIf_SendMessage(0, CanTxMsg);
	}

	if(AskData.DataPtr)
	{
		free(AskData.DataPtr);
	}
	AskData.DataPtr = NULL;
}
void BleCanTransmit(uint32 AskCanID, uint8 AskData[])
{
	Can_Msg_Type CanTxMsg;
	uint32 AnsCanID = 0;
	uint8 AnsData[8];
	memset(AnsData, 0x00, 8);
	static QueueDataTrans_Type CanAnsData={0,NULL};
	static uint8 CanDataCounter = 0;//数据打包需要的包数
	static uint8 DataPackDone = 0;//已打包数目
	static uint8 CanByte0Idx = 0;
	static volatile uint8 PackState = 0;//0-未打包，1-正在打包，2-打包完成
	uint8 CanAnsPerLen = 7;
	uint8 CanByte0Seq = 0;
	switch (AskCanID)
	{
	case 0X1CEE0000: //数据通道，换电控制的数据发过来在此打包后转uart2
	{
		if(PackState==0)
		{
			DataPackDone = 0;
			CanDataCounter = DataPackCounter[(AskData[0]>>4)];
			CanAnsData.RealLen = CanDataCounter*CanAnsPerLen + 2;
			CanAnsData.DataPtr = malloc(CanAnsData.RealLen);
			memset(CanAnsData.DataPtr,0x00,CanAnsData.RealLen);
			CanByte0Idx = (AskData[0]>>4);
			PackState = 1;
		}
		if(PackState==1)
		{
			if(CanByte0Idx==(AskData[0]>>4))
			{
				CanByte0Seq = (AskData[0])&0x0F;
				if(CanByte0Idx==4)
				{
					CanByte0Seq = CanByte0Seq + 1;
				}
				if(DataPackDone<CanDataCounter)
				{
					memcpy(CanAnsData.DataPtr+(CanByte0Seq - 1)*CanAnsPerLen,AskData,CanAnsPerLen);//从CAN信息中只截取前7个数据
					DataPackDone++;
				}
				if(DataPackDone==CanDataCounter)
				{
					CanAnsData.RealLen = DataPackDone*CanAnsPerLen + 2;
					PackState = 2;
				}
			}
			else//序号不对，打包立刻完成，更改数据长度
			{
				CanAnsData.RealLen = DataPackDone*CanAnsPerLen + 2;
				PackState = 2;
			}
		}
		if(PackState==2)
		{
			uint16 CrcCal = 0;
			CrcCal = CRC16_Modbus(CanAnsData.DataPtr,CanAnsData.RealLen-2);
			*(CanAnsData.DataPtr + CanAnsData.RealLen-2) = CrcCal &0xFF;
			*(CanAnsData.DataPtr + CanAnsData.RealLen-1) = (CrcCal>>8) &0xFF;
			if(xQueueSend(CanToUart2DataHandle,&CanAnsData,1000*10)!=pdPASS)
			{
				if(CanAnsData.DataPtr)
				{
					free(CanAnsData.DataPtr);
				}
				CanAnsData.DataPtr = NULL;
				CanAnsData.RealLen = 0;
			}
			PackState = 0;
		}
		CanTxMsg.id = AnsCanID;
		CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
		CanTxMsg.sdu = AnsData;
		CanTxMsg.length = 8;
		CanIf_SendMessage(0, CanTxMsg);
		return;
	}
	case 0X1CEE0001: //查询
	{
		if (AskData[0] == 1) //软件版本查询
		{
			AnsData[0] = 0x01;
			AnsData[1] = (BleVersion >> 24) & 0xFF;
			AnsData[2] = (BleVersion >> 16) & 0xFF;
			AnsData[3] = (BleVersion >> 8) & 0xFF;
			AnsData[4] = (BleVersion >> 0) & 0xFF;
		}
		else if (AskData[0] == 2) // Mac地址查询
		{
			AnsData[0] = 0x02;
			AnsData[1] = (BleMacAddr[0]) & 0xFF;
			AnsData[2] = (BleMacAddr[1]) & 0xFF;
			AnsData[3] = (BleMacAddr[2]) & 0xFF;
			AnsData[4] = (BleMacAddr[3]) & 0xFF;
			AnsData[5] = (BleMacAddr[4]) & 0xFF;
			AnsData[6] = (BleMacAddr[5]) & 0xFF;
		}
		AnsCanID = 0X1CEF0001;
		CanTxMsg.id = AnsCanID;
		CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
		CanTxMsg.sdu = AnsData;
		CanTxMsg.length = 8;
		CanIf_SendMessage(0, CanTxMsg);
		break;
	}
	case 0X1CEE0002: //连接控制
	{
		if (AskData[0] == 1) //连接状态查询
		{
			AnsData[0] = 0x01;
			AnsData[1] = (BleDisconnectFlg<<1)|(BleConnectFlg);
		}
		else if (AskData[0] == 2) //连接指定Mac地址
		{
			BleTargetMacAddr[0] = AskData[1];
			BleTargetMacAddr[1] = AskData[2];
			BleTargetMacAddr[2] = AskData[3];
			BleTargetMacAddr[3] = AskData[4];
			BleTargetMacAddr[4] = AskData[5];
			BleTargetMacAddr[5] = AskData[6];
			BleConnectEnable = 1;
			AnsData[0] = 2;
			AnsData[1] = 2;
		}
		else if (AskData[0] == 3) //断开连接
		{
			BleDisconnectEnable = 1;
			AnsData[0] = 3;
			AnsData[1] = 3;
		}
		AnsCanID = 0X1CEF0002;
		CanTxMsg.id = AnsCanID;
		CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
		CanTxMsg.sdu = AnsData;
		CanTxMsg.length = 8;
		CanIf_SendMessage(0, CanTxMsg);
		break;
	}
	case 0X1CEE0003: //角色控制
	{
		if (AskData[0] == 1) //当前角色查询
		{
			AnsData[0] = 0x01;
			AnsData[1] = BleCurrentRole;
		}
		else if (AskData[0] == 2) //角色设置
		{
			BleSetRoleEnable = 1;
			BleSetRole = AskData[1] & 0x03;
			AnsData[0] = 0x02;
			AnsData[1] = BleSetRole;
		}
		AnsCanID = 0X1CEF0003;
		CanTxMsg.id = AnsCanID;
		CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
		CanTxMsg.sdu = AnsData;
		CanTxMsg.length = 8;
		CanIf_SendMessage(0, CanTxMsg);
		break;
	}
	case 0X1CEE0004: //蓝牙开关机控制
	{
		if (AskData[0] == 1)
		{
			if (AskData[1] == 0) //开机
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 0;
			}
			else if (AskData[1] == 1) //关机
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 1;
			}
			else if (AskData[1] == 2) //重启
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 2;
			}
			AnsData[0] = 1;
			AnsData[1] = AskData[1];
		}
		AnsCanID = 0X1CEF0004;
		CanTxMsg.id = AnsCanID;
		CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
		CanTxMsg.sdu = AnsData;
		CanTxMsg.length = 8;
		CanIf_SendMessage(0, CanTxMsg);
		break;
	}
	case 0x1C00EBEA:
	{
		udsService(AskData);
		break;
	}
	default:
		return;
		break;
	}
	return;
}
void udsService(uint8 *DataIn)
{
	static uint8 udsMode = 0;
	uint8 UdsService = *(DataIn + 0);
	uint8 UdsSubService = *(DataIn + 1);
	uint8 AnsData[8]={0};
	switch(UdsService)
	{
	case 0x10:
	{
		if(UdsSubService==0x01)
		{
			udsMode = 1;
			UdsAns(true,UdsService,UdsSubService,0x00,NULL,0);
		}
		else if(*(DataIn+1)==0x02)
		{
			if(udsMode==1||udsMode==2)
			{
				udsMode = 2;
				UdsAns(true,UdsService,UdsSubService,0x00,NULL,0);
			}
			else
			{
				udsMode = 0;
				UdsAns(false,UdsService,UdsSubService,0x00,NULL,0);
			}
		}
		else
		{
			udsMode = 0;
			UdsAns(false,UdsService,UdsSubService,0x00,NULL,0);
		}
		break;
	}
	case 0x22:
	{
		if(udsMode==2)
		{
			switch(UdsSubService)
			{
			case 0x01://软件版本查询
			{
				AnsData[0] = (BleVersion >> 24) & 0xFF;
				AnsData[1] = (BleVersion >> 16) & 0xFF;
				AnsData[2] = (BleVersion >> 8) & 0xFF;
				AnsData[3] = (BleVersion >> 0) & 0xFF;
				UdsAns(true,UdsService,UdsSubService,0x00,AnsData,4);
				break;
			}
			case 0x02://MAC地址查询
			{
				memcpy(AnsData,BleMacAddr,6);
				for(uint8 i=0;i<2;i++)
				{
					UdsAns(true,UdsService,UdsSubService,i,&AnsData[i*4],4);
				}
				break;
			}
			case 0x03://角色查询
			{
				AnsData[0] = (BleCurrentRole) & 0xFF;
				UdsAns(true,UdsService,UdsSubService,0x00,AnsData,1);
				break;
			}
			case 0x04://连接查询
			{
				AnsData[0] = (BleConnectFlg) & 0xFF;
				UdsAns(true,UdsService,UdsSubService,0x00,AnsData,1);
				break;
			}
			default:
			{
				UdsAns(false,UdsService,UdsSubService,0x00,NULL,0);
				break;
			}
			}
		}
		else
		{
			UdsAns(false,UdsService,UdsSubService,0x00,NULL,0);
		}
		break;
	}
	default:
	{
		UdsAns(false,0x00,0x00,0x00,NULL,0);
		break;
	}
	}
}
static void UdsAns(bool PosFlg,uint8 UdsService,uint8 UdsSubService,uint8 Idx,uint8 *AnsData,uint8 AnsDataLen)
{
	Can_Msg_Type CanTxMsg;
	uint32 CanAnsId = 0x1C00EAEB;
	uint8 SendData[8] = {0};
	if(PosFlg)
	{
		SendData[0] = 0x78;
		SendData[1] = UdsService;
		SendData[2] = UdsSubService;
		SendData[3] = Idx;
		if(AnsData!=NULL&&AnsDataLen!=0x00)
		{
			memcpy(&SendData[4],AnsData,AnsDataLen);
		}
	}
	else
	{
		SendData[0] = 0x7F;
		SendData[1] = UdsService;
		SendData[2] = UdsSubService;
		SendData[3] = 0x00;
	}
	CanTxMsg.id = CanAnsId;
	CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
	CanTxMsg.sdu = SendData;
	CanTxMsg.length = 8;
	CanIf_SendMessage(0, CanTxMsg);
}
