/*
 * AppTaskUart0.c
 *
 *  Created on: 
 *      Author: QiXiang_CHENJIE
 */
#include "AppTaskUart0.h"
const McuAtCmdFunc_t McuAtCmdFunc[] =
{
	{MAT, "AT", McuAtCallbackFunc},
	{MAT_Version, "AT+VERSION?", McuAtCallbackFunc},
	{MAT_Connect, "AT+CONNECT=", McuAtCallbackFunc},
	{MAT_DisConnect, "AT+DISCONNECT", McuAtCallbackFunc},
	{MAT_Msg, "AT+MSG=", McuAtCallbackFunc},
	{MAT_NameSet, "AT+NAME=", McuAtCallbackFunc},
	{MAT_Power, "AT+POWER=", McuAtCallbackFunc},
	{MAT_Role, "AT+ROLE=", McuAtCallbackFunc},
	{MAT_GetMac, "AT+MAC=?", McuAtCallbackFunc},
	{MAT_Wset, "AT+WSET=", McuAtCallbackFunc},
	{MAT_Wmsg, "AT+WMSG=", McuAtCallbackFunc},//此命令变化，416行长度也需要同步修改
	{MAT_Wconchk, "AT+WCONNCHK=?", McuAtCallbackFunc},
	{MAT_Wrole, "AT+WROLE=", McuAtCallbackFunc},
	{MAT_CMD_MAXNUM,"ERROR",McuAtCallbackFunc},
};
void UartTask(void *pvParameters)
{
	(void)pvParameters;
	ConnSemaphore = xSemaphoreCreateBinary();
	McuDataSendHandle = xQueueCreate(2, 10);
	McuDataRecvHandle = xQueueCreate(1, sizeof(QueueDataTrans_Type));
	McuDataSend_wifi = xQueueCreate(2, 10);
	McuDataRecv_wifi = xQueueCreate(1, sizeof(QueueDataTrans_Type));
	char AtCmdRead[128] = {0};
	char AtCmdAns[256] = {0};
	uint16 AtCmdAnsLen;
	uint8 RecvRet = 1;
	uint16 ReadLen = 0;
	for (;;)
	{
		memset(AtCmdRead,0x00,sizeof(AtCmdRead));
		RecvRet = UART_Receive_Data(UART_LPUART0, AtCmdRead,&ReadLen, 100);
		if(!RecvRet)
		{
			AtCmdAnsLen = 0;
			memset(AtCmdAns,0x00,sizeof(AtCmdAns));
			McuATCmdTransmit(AtCmdRead, ReadLen, AtCmdAns, &AtCmdAnsLen);
			UART_Send_Data(UART_LPUART0,AtCmdAns,AtCmdAnsLen,100);
		}
	}
}
void McuATCmdTransmit(char *Readptr, uint16 Readlen, char *AnsPtr, uint8 *AnsPtrLen)
{

	uint8 ret = 0;
	for (uint8 i = 0; i < MAT_CMD_MAXNUM; i++)
	{
		ret = AtStrCompare(Readptr, McuAtCmdFunc[i].str);
		if (ret)
		{
			McuAtCmdFunc[i].cb(Readptr,Readlen, i, AnsPtr, AnsPtrLen);
			return;
		}
	}
	McuAtCmdFunc[MAT_CMD_MAXNUM].cb(Readptr,Readlen, MAT_CMD_MAXNUM, AnsPtr, AnsPtrLen);
	return;
}
sint8 McuAtCallbackFunc(char *Readptr, uint16 ReadLen, McuAtCmd McuAtIdx, char *AnsPtr, uint8 *AnsPtrLen)
{

	char *SucAns = "OK\r\n";
	char *ErrAns = "ERROR\r\n";
	char *OffAns = "OFF\r\n";
	char *OnAns = "ON\r\n";
	char *SlaveAns = "S";
	char *MasterAns = "M";
	switch (McuAtIdx)
	{
		case MAT:
		{
			*AnsPtrLen = strlen(SucAns);
			memcpy(AnsPtr, SucAns, *AnsPtrLen);
			break;
		}
		case MAT_Version:
		{
			uint8 chartemp;
			memcpy(AnsPtr, SucAns, strlen(SucAns));
			*AnsPtrLen = strlen(SucAns);
			for (uint8 i = 0; i < sizeof(BleVersion) * 2; i++)
			{
				chartemp = HexToChar(BleVersion >> (28 - 4 * i));
				memcpy(AnsPtr + *AnsPtrLen + i, &chartemp, 1);
			}

			*AnsPtrLen = sizeof(BleVersion) * 2 + *AnsPtrLen;
			break;
		}
		case MAT_Connect:
		{
			if (ReadLen == (strlen((McuAtCmdFunc[McuAtIdx].str)) + 12))
			{
				if (BleConnectFlg)
				{
					memcpy(AnsPtr, SucAns, strlen(SucAns));
					*AnsPtrLen = strlen(SucAns);
					memcpy(AnsPtr + *AnsPtrLen, OnAns, strlen(OnAns));
					*AnsPtrLen = *AnsPtrLen + strlen(OnAns);
				}
				else
				{
					if (BleCurrentRole == 1)
					{
						for(uint8 i=0;i<6;i++)
						{
							uint8 temp1 = 0x00;
							uint8 temp2 = 0x00;
							temp1 = (CharToHex(*(Readptr + i*2 + strlen(McuAtCmdFunc[McuAtIdx].str)))<<4);
							temp2 = CharToHex(*(Readptr + i*2 + 1 + strlen(McuAtCmdFunc[McuAtIdx].str)));
							BleTargetMacAddr[i] = temp1|temp2;
						}
						BleConnectEnable = 1;
						if( xSemaphoreTake( ConnSemaphore, 5000 ) == pdTRUE )
						{
							memcpy(AnsPtr, SucAns, strlen(SucAns));
							*AnsPtrLen = strlen(SucAns);
							memcpy(AnsPtr + *AnsPtrLen, (char *)("SUC\n"), strlen((char *)("SUC\n")));
							*AnsPtrLen = *AnsPtrLen + strlen((char *)("SUC\n"));
						}
						else
						{
							memcpy(AnsPtr, ErrAns, strlen(ErrAns));
							*AnsPtrLen = strlen(ErrAns);
							memcpy(AnsPtr + *AnsPtrLen, (char *)("-1\n"), strlen((char *)("-1\n")));
							*AnsPtrLen = *AnsPtrLen + strlen((char *)("-1\n"));
						}
					}
					else
					{
						*AnsPtrLen = strlen((char *)ErrAns);
						memcpy(AnsPtr, ErrAns, *AnsPtrLen);
					}
				}
			}
			else if (*(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str)) == '?')
			{
				if (BleConnectFlg)
				{
					if (BleCurrentRole == 1)
					{

						memcpy(AnsPtr, SucAns, strlen(SucAns));
						*AnsPtrLen = strlen(SucAns);
						memcpy(AnsPtr + *AnsPtrLen, OnAns, strlen(OnAns));
						*AnsPtrLen = *AnsPtrLen + strlen(OnAns);
						for(uint8 i=0;i<6;i++)
						{
							*(AnsPtr + *AnsPtrLen + i*2) = HexToChar((BleTargetMacAddr[i]>>4)&0x0F);
							*(AnsPtr + *AnsPtrLen + i*2 + 1) = HexToChar(BleTargetMacAddr[i]&0x0F);
						}
						*AnsPtrLen = *AnsPtrLen + sizeof(BleTargetMacAddr)*2;
						break;
					}
					else
					{
						memcpy(AnsPtr, SucAns, strlen(SucAns));
						*AnsPtrLen = strlen(SucAns);
						memcpy(AnsPtr + *AnsPtrLen, OnAns, strlen(OnAns));
						*AnsPtrLen = *AnsPtrLen + strlen(OnAns);
					}
				}
				else
				{
					memcpy(AnsPtr, SucAns, strlen(SucAns));
					*AnsPtrLen = strlen(SucAns);
					memcpy(AnsPtr + *AnsPtrLen, OffAns, strlen(OffAns));
					*AnsPtrLen = *AnsPtrLen + strlen(OffAns);
				}
			}
			else
			{
				*AnsPtrLen = strlen((char *)ErrAns);
				memcpy(AnsPtr, ErrAns, *AnsPtrLen);
			}
			break;
		}
		case MAT_DisConnect:
		{
			BleDisconnectEnable = 1;
			memcpy(AnsPtr, SucAns, strlen(SucAns));
			*AnsPtrLen = strlen(SucAns);
			break;
		}
		case MAT_Msg:
		{
			uint8 Databuffer[10] = {0};
			uint16 CrcChkGet;
			uint16 CrcChkCal;

			if(BleConnectFlg)
			{
				if(*(Readptr+7)=='0' && *(Readptr+9)=='1'&& *(Readptr+10)=='0'&& ReadLen==22)//Hex
				{
					memcpy(Databuffer,Readptr+12,8);
					CrcChkGet = (*(Readptr+12+8))|(*(Readptr+12+9)<<8);
				}
				else if(*(Readptr+7)=='1'&&*(Readptr+9)=='2'&& *(Readptr+10)=='0' && ReadLen==32)//string
				{
					for(uint8 i=0;i<8;i++)
					{
						Databuffer[i] = (CharToHex(*(Readptr+12+i*2))<<4) | (CharToHex(*(Readptr+12+i*2+1))<<0);
					}
					CrcChkGet = (CharToHex(*(Readptr+12+18))<<12) | (CharToHex(*(Readptr+12+19))<<8)|(CharToHex(*(Readptr+12+16))<<4) | (CharToHex(*(Readptr+12+17))<<0);
				}
				else
				{
					memcpy(AnsPtr, ErrAns, strlen(ErrAns));
					*AnsPtrLen = strlen(ErrAns);
					memcpy(AnsPtr + *AnsPtrLen, (char *)("-1\n"), strlen((char *)("-1\n")));
					*AnsPtrLen = *AnsPtrLen + strlen((char *)("-1\n"));
					break;
				}
				CrcChkCal = CRC16_Modbus (Databuffer, 8);
				if(CrcChkCal==CrcChkGet)
				{
					AT_MsgFlag = true;
					Databuffer[8] = CrcChkGet&0xff;
					Databuffer[9] = (CrcChkGet>>8)&0xff;
					xQueueSend(McuDataSendHandle,Databuffer,1000);
					QueueDataTrans_Type RecvDatabuffer={0,NULL};
					sint8 QueneRetRev = -1;
					xQueueReset(McuDataRecvHandle);
					QueneRetRev = xQueueReceive(McuDataRecvHandle,&RecvDatabuffer,1000*3);//����wifi���ն���
					if(QueneRetRev==pdPASS)
					{
						uint8 DataLen = RecvDatabuffer.RealLen;
						CrcChkGet = 0x00;
						CrcChkCal = 0xff;
						CrcChkGet = (*(RecvDatabuffer.DataPtr+DataLen-1)<<8)| (*(RecvDatabuffer.DataPtr+DataLen-2));
						CrcChkCal = CRC16_Modbus(RecvDatabuffer.DataPtr,DataLen-2);
						if(CrcChkCal==CrcChkGet)
						{
							memcpy(AnsPtr + *AnsPtrLen, (char *)("Recv:OK,"), strlen((char *)("Recv:OK,")));
							*AnsPtrLen = *AnsPtrLen + strlen((char *)("Recv:OK,"));
							//��Ҫת��ΪASCII�뷢��
							for(uint8 i=0;i<DataLen;i++)
							{
								*(AnsPtr + *AnsPtrLen + i*2 + 0) = HexToChar((*(RecvDatabuffer.DataPtr+i)>>4)&0x0F);
								*(AnsPtr + *AnsPtrLen + i*2 + 1) = HexToChar((*(RecvDatabuffer.DataPtr+i)&0x0F));
							}
							*AnsPtrLen = *AnsPtrLen + DataLen*2;
							//ֱ�ӷ���memcpy(AnsPtr + *AnsPtrLen,RecvDatabuffer.DataPtr,DataLen);
							//*AnsPtrLen = *AnsPtrLen + DataLen;
						}
						else
						{
							memcpy(AnsPtr + *AnsPtrLen, (char *)("Recv:ERROR,-2"), strlen((char *)("Recv:ERROR,-2")));
							*AnsPtrLen = *AnsPtrLen + strlen((char *)("Recv:ERROR,-2"));
						}
					}
					else
					{
						memcpy(AnsPtr + *AnsPtrLen, (char *)("Recv:ERROR,-1"), strlen((char *)("Recv:ERROR,-1")));
						*AnsPtrLen = *AnsPtrLen + strlen((char *)("Recv:ERROR,-1"));
					}
					if(RecvDatabuffer.DataPtr!=NULL)
					{
						free(RecvDatabuffer.DataPtr);
					}
					RecvDatabuffer.DataPtr = NULL;
					break;
				}
				else
				{
					memcpy(AnsPtr, ErrAns, strlen(ErrAns));
					*AnsPtrLen = strlen(ErrAns);
					memcpy(AnsPtr + *AnsPtrLen, (char *)("-2\n"), strlen((char *)("-2\n")));
					*AnsPtrLen = *AnsPtrLen + strlen((char *)("-2\n"));
					break;
				}

			}
			else
			{
				memcpy(AnsPtr, ErrAns, strlen(ErrAns));
				*AnsPtrLen = strlen(ErrAns);
				memcpy(AnsPtr + *AnsPtrLen, OffAns, strlen(OffAns));
				*AnsPtrLen = *AnsPtrLen + strlen(OffAns);
			}
			break;
		}
		case MAT_NameSet:
		{
			*AnsPtrLen = strlen((char *)ErrAns);
			memcpy(AnsPtr, ErrAns, *AnsPtrLen);
			break;
		}
		case MAT_Power:
		{
			if (*(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str)) == '?')
			{
				if (BlePwrState == 0) //Ϊ0����
				{
					memcpy(AnsPtr, SucAns, strlen(SucAns));
					*AnsPtrLen = strlen(SucAns);
					memcpy(AnsPtr + *AnsPtrLen, OnAns, strlen(OnAns));
					*AnsPtrLen = *AnsPtrLen + strlen(OnAns);
				}
				else
				{
					memcpy(AnsPtr, SucAns, strlen(SucAns));
					*AnsPtrLen = strlen(SucAns);
					memcpy(AnsPtr + *AnsPtrLen, OffAns, strlen(OffAns));
					*AnsPtrLen = *AnsPtrLen + strlen(OffAns);
				}
			}
			else if (*(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str)) == 'O' && *(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str) + 1) == 'N')
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 0;
				memcpy(AnsPtr, SucAns, strlen(SucAns));
				*AnsPtrLen = strlen(SucAns);
			}
			else if (*(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str)) == 'O' && *(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str) + 1) == 'F' && *(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str) + 2) == 'F')
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 1;
				memcpy(AnsPtr, SucAns, strlen(SucAns));
				*AnsPtrLen = strlen(SucAns);
			}
			else
			{
				*AnsPtrLen = strlen((char *)ErrAns);
				memcpy(AnsPtr, ErrAns, *AnsPtrLen);
			}
			break;
		}
		case MAT_Role: //��ɫ��ѯ������
		{
			if (*(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str)) == '?')
			{
				if (BleCurrentRole == 0) //Ϊ0�ӻ�
				{
					memcpy(AnsPtr, SucAns, strlen(SucAns));
					*AnsPtrLen = strlen(SucAns);
					memcpy(AnsPtr + *AnsPtrLen, SlaveAns, strlen(SlaveAns));
					*AnsPtrLen = *AnsPtrLen + strlen(SlaveAns);
				}
				else
				{
					memcpy(AnsPtr, SucAns, strlen(SucAns));
					*AnsPtrLen = strlen(SucAns);
					memcpy(AnsPtr + *AnsPtrLen, MasterAns, strlen(MasterAns));
					*AnsPtrLen = *AnsPtrLen + strlen(MasterAns);
				}
			}
			else if (*(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str)) == *MasterAns)
			{
				BleSetRoleEnable = 1;
				BleSetRole = 1;
				memcpy(AnsPtr, SucAns, strlen(SucAns));
				*AnsPtrLen = strlen(SucAns);
			}
			else if (*(Readptr + strlen(McuAtCmdFunc[McuAtIdx].str)) == *SlaveAns)
			{
				BleSetRoleEnable = 1;
				BleSetRole = 0;
				memcpy(AnsPtr, SucAns, strlen(SucAns));
				*AnsPtrLen = strlen(SucAns);
			}
			else
			{
				*AnsPtrLen = strlen((char *)ErrAns);
				memcpy(AnsPtr, ErrAns, *AnsPtrLen);
			}
			break;
		}
		case MAT_GetMac:
		{
			memcpy(AnsPtr, SucAns, strlen(SucAns));
			*AnsPtrLen = strlen(SucAns);
			for(uint8 i=0;i<6;i++)
			{
				*(AnsPtr + *AnsPtrLen + i*2) = HexToChar((BleMacAddr[i]>>4)&0x0F);
				*(AnsPtr + *AnsPtrLen + i*2 + 1) = HexToChar(BleMacAddr[i]&0x0F);
			}
			*AnsPtrLen = *AnsPtrLen + sizeof(BleMacAddr)*2;
			break;
		}
		case MAT_Wconchk:
		{
			if (wifiConnFlg)
			{
				memcpy(AnsPtr, SucAns, strlen(SucAns));
				*AnsPtrLen = strlen(SucAns);
				memcpy(AnsPtr + *AnsPtrLen, OnAns, strlen(OnAns));
				*AnsPtrLen = *AnsPtrLen + strlen(OnAns);
			}
			else
			{
				memcpy(AnsPtr, SucAns, strlen(SucAns));
				*AnsPtrLen = strlen(SucAns);
				memcpy(AnsPtr + *AnsPtrLen, OffAns, strlen(OffAns));
				*AnsPtrLen = *AnsPtrLen + strlen(OffAns);
			}
			break;
		}
		case MAT_Wmsg:
		{
			uint8 Databuffer[10] = {0};
			uint16 CrcChkGet;
			uint16 CrcChkCal;
			uint8 DataLen = 0;
			sint8 QueneRetRev = -1;
			if(wifiConnFlg)
			{
				if(*(Readptr+8)=='0' && *(Readptr+10)=='1'&& *(Readptr+11)=='0'&& ReadLen==23)//Hex
				{
					memcpy(Databuffer,Readptr+12,8);
					CrcChkGet = (*(Readptr+12+8))|(*(Readptr+12+9)<<8);
				}
				else if(*(Readptr+8)=='1'&&*(Readptr+10)=='2'&& *(Readptr+11)=='0' && ReadLen==33)//string
				{
					for(uint8 i=0;i<8;i++)
					{
						Databuffer[i] = (CharToHex(*(Readptr+13+i*2))<<4) | (CharToHex(*(Readptr+13+i*2+1))<<0);
					}
					CrcChkGet = (CharToHex(*(Readptr+13+18))<<12) | (CharToHex(*(Readptr+13+19))<<8)|(CharToHex(*(Readptr+13+16))<<4) | (CharToHex(*(Readptr+13+17))<<0);
				}
				else
				{
					memcpy(AnsPtr, ErrAns, strlen(ErrAns));
					*AnsPtrLen = strlen(ErrAns);
					memcpy(AnsPtr + *AnsPtrLen, (char *)("-1\n"), strlen((char *)("-1\n")));
					*AnsPtrLen = *AnsPtrLen + strlen((char *)("-1\n"));
					break;
				}
				CrcChkCal = CRC16_Modbus (Databuffer, 8);
				if(CrcChkCal==CrcChkGet)
				{
					wifiAskFlg = true;
					Databuffer[8] = CrcChkGet&0xff;
					Databuffer[9] = (CrcChkGet>>8)&0xff;
					xQueueSend(McuDataSend_wifi,Databuffer,1000);
					QueueDataTrans_Type RecvDatabuffer={0,NULL};
					xQueueReset(McuDataRecv_wifi);
					QueneRetRev = xQueueReceive(McuDataRecv_wifi,&RecvDatabuffer,1000*2);
					if(QueneRetRev==pdPASS)
					{
						DataLen = RecvDatabuffer.RealLen;
						CrcChkGet = 0x00;
						CrcChkCal = 0xff;
						CrcChkGet = (*(RecvDatabuffer.DataPtr+DataLen-1)<<8)| (*(RecvDatabuffer.DataPtr+DataLen-2));
						CrcChkCal = CRC16_Modbus(RecvDatabuffer.DataPtr,DataLen-2);
						if(CrcChkCal==CrcChkGet)
						{
							memcpy(AnsPtr + *AnsPtrLen, (char *)("Recv:OK,"), strlen((char *)("Recv:OK,")));
							*AnsPtrLen = *AnsPtrLen + strlen((char *)("Recv:OK,"));
							for(uint8 i=0;i<DataLen;i++)
							{
								*(AnsPtr + *AnsPtrLen + i*2 + 0) = HexToChar((*(RecvDatabuffer.DataPtr+i)>>4)&0x0F);
								*(AnsPtr + *AnsPtrLen + i*2 + 1) = HexToChar((*(RecvDatabuffer.DataPtr+i)&0x0F));
							}
							*AnsPtrLen = *AnsPtrLen + DataLen*2;
						}
						else
						{
							memcpy(AnsPtr + *AnsPtrLen, (char *)("Recv:ERROR,-2"), strlen((char *)("Recv:ERROR,-2")));
							*AnsPtrLen = *AnsPtrLen + strlen((char *)("Recv:ERROR,-2"));
						}
					}
					else
					{
						memcpy(AnsPtr + *AnsPtrLen, (char *)("Recv:ERROR,-1"), strlen((char *)("Recv:ERROR,-1")));
						*AnsPtrLen = *AnsPtrLen + strlen((char *)("Recv:ERROR,-1"));
					}
					if(RecvDatabuffer.DataPtr!=NULL)
					{
						free(RecvDatabuffer.DataPtr);
					}
					RecvDatabuffer.DataPtr = NULL;
					break;
				}
				else
				{
					memcpy(AnsPtr, ErrAns, strlen(ErrAns));
					*AnsPtrLen = strlen(ErrAns);
					memcpy(AnsPtr + *AnsPtrLen, (char *)("-2\n"), strlen((char *)("-2\n")));
					*AnsPtrLen = *AnsPtrLen + strlen((char *)("-2\n"));
					break;
				}

			}
			else
			{
				memcpy(AnsPtr, ErrAns, strlen(ErrAns));
				*AnsPtrLen = strlen(ErrAns);
				memcpy(AnsPtr + *AnsPtrLen, OffAns, strlen(OffAns));
				*AnsPtrLen = *AnsPtrLen + strlen(OffAns);
			}
			break;
		}
		case MAT_CMD_MAXNUM:
		{
			*AnsPtrLen = strlen((char *)ErrAns);
			memcpy(AnsPtr, ErrAns, *AnsPtrLen);
			break;
		}
		default:
			break;
	}
	return 0;
}
